<template>
  <div v-if="errorObject">
    Error state: {{ errorObject }}
    <stateful-button v-if="retry" :click="retry">Retry</stateful-button>
  </div>
  <div v-else-if="loading">
    <loading-dots />
  </div>
  <div v-else-if="empty">
    <slot name="empty">No records found</slot>
  </div>
  <div v-else>
    <slot />
  </div>
</template>
<style lang="scss" scoped>

@import "~assets/mixins";

.null-state {
  display: flex;
  flex-direction: column;
  justify-content: center;
  text-align: center;
}

</style>
<script>

export default {
  props: {
    'data': {},
    'error': { default: null },
    'retry': {default: null},
  },
  computed: {
    errorObject() {
      var error = this.error;
      var data = this.data;

      if(error) return error;
      if(data instanceof Error) return data;
      if(data === null || typeof data === 'undefined') return false;
      if('error' in data || 'errors' in data) return data;

      return null;
    },
    loading() {
      var error = this.error;
      var data = this.data;

      if(error) return false;
      if(data === null || typeof data === 'undefined') return true;

      return false;
    },
    empty() {
      var error = this.errorObject;
      var data = this.data;

      if(this.loading) return false;
      if('length' in data && data.length === 0) return true;
      return false;
    }
  }
}

</script>
